
#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; 
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb USICR=0x0d;
sfrb USISR=0x0e;
sfrb USIDR=0x0f;
sfrb USIBR=0x10;
sfrb GPIOR0=0x11;
sfrb GPIOR1=0x12;
sfrb GPIOR2=0x13;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb PRR=0x20;
sfrb WDTCR=0x21;
sfrb DWDR=0x22;
sfrb DTPS=0x23;
sfrb DTVALB=0x24;
sfrb DTVALC=0x25;
sfrb CLKPR=0x26;
sfrb PLLCSR=0x27;
sfrb OCR0B=0x28;
sfrb OCR0A=0x29;
sfrb TCCR0A=0x2a;
sfrb OCR1B=0x2b;
sfrb GTCCR=0x2c;
sfrb OCR1C=0x2d;
sfrb OCR1A=0x2e;
sfrb TCNT1=0x2f;
sfrb TCCR1=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

bit half;
unsigned char start[64];
unsigned char memory;
unsigned char Parity; 
unsigned char cursor,status; 
unsigned char ver[5];  
unsigned char i,j;
void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{

while(EECR & (1<<1 ))
;
EECR=(0<<5 )|(0<4 );

EEARL = uiAddress;
EEDR = ucData;

EECR |= (1<<2);

EECR |= (1<<1 );
}
unsigned char EEPROM_read(unsigned int uiAddress)
{

while(EECR & (1<<1 ))
;

EEARL = uiAddress;

EECR |= (1<<0 );

return EEDR;
}

interrupt [11] void timer0_compa_isr(void)
{
while(PINB.2==half){}
half^=1;
PORTB.0=start[cursor]^(~half);
if(half) if(!cursor--) cursor=63;
}

void main(void)
{
PORTB=0x3E;
DDRB=0x01;

TCCR0A=0x02;
TCCR0B=0x07;
TCNT0=0x00;
OCR0A=0x20;
OCR0B=0x00;

GIMSK=0x00;
MCUCR=0x00;

TIMSK=0x10;

ACSR=0x80;
ADCSRB=0x00;

for(cursor=63;cursor>54;cursor--)start[cursor]=1;
cursor=54;
for(i=0;i<5;i++){
j = 8;  Parity=0; status=0;
memory = EEPROM_read(i);               
while(j--){
if ( memory & 0x80 ){ start[cursor]=1; ver[status]++; Parity++; }
else start[cursor]=0; 
cursor--;
status++;
if(j==4||j==0){  start[cursor]=(Parity & 1);  Parity=0; cursor--; status=0;}
memory<<= 1;
}
}
start[4]=(ver[0]&1);
start[3]=(ver[1]&1);
start[2]=(ver[2]&1);
start[1]=(ver[3]&1);
start[0]=0;
cursor=63;
#asm("sei")

while (1)
{

};
}
